<template>
  <div id="home" class="position-fixed w-100 p-3">
    <b-container fluid class="title-header m-0 p-0">
      <b-row class="row-title w-100 m-0 align-items-center">
        <b-col class="text-left px-0 py-2">
          <h6 class="mb-0">Yearly Member 01-Jan-2020 to 31-Dec-2020</h6>
        </b-col>
        <b-col class="row-filter px-0 py-2">
          <div class="float-left">
            <b-form-select
              v-model="selectViewer"
              :options="viewOptions"
            ></b-form-select>
          </div>
          <div class="float-left ml-2">
            <b-form-input
              type="date"
              v-model="year"
              align="right"
            ></b-form-input>
          </div>
        </b-col>
      </b-row>
      <b-row class="row-summary-tier w-100 m-0 p-0">
        <b-col cols="5">
          <b-row class="w-100 m-0 align-items-center">
            <b-col cols="6" class="p-0 text-left">
              <h6 class="py-2">Total Members:</h6>
              <h6 class="py-2">Total Rev.(THB):</h6>
            </b-col>
            <b-col cols="6" class="p-0 text-right">
              <h5 class="py-2">
                {{ $store.state.yearlyMember.summarytier[0].total_members }}
              </h5>
              <h5 class="py-2">
                {{
                  $store.state.yearlyMember.summarytier[0].total_amount
                    | convertK
                }}
              </h5>
            </b-col>
          </b-row>
        </b-col>
        <b-col cols="7">
          <b-row class="w-100 m-0 align-items-center">
            <b-col cols="12"
              ><h6 class="py-2">
                {{ $store.state.yearlyMember.summarytier[0].tier_name }}
              </h6></b-col
            >
            <b-col cols="6" class="p-0 text-left">
              <h6 class="py-1 mb-0">Total Members:</h6>
              <h6 class="py-1 mb-0">Total Rev.(THB):</h6>
            </b-col>
            <b-col cols="6" class="p-0 text-right">
              <h6 class="py-1 mb-0">
                {{ $store.state.yearlyMember.summarytier[0].total_members }}
              </h6>
              <h6 class="py-1 mb-0">
                {{
                  $store.state.yearlyMember.summarytier[0].total_amount
                    | convertK
                }}
              </h6>
            </b-col>
          </b-row>
        </b-col>
      </b-row>
    </b-container>
    <b-table
      :items="$store.state.yearlyMember.list"
      :fields="fields"
      :current-page="currentPage"
      :per-page="perPage"
      :striped="true"
      :bordered="true"
      :fixed="true"
      stacked="md"
      show-empty
      small
    >
    </b-table>
    <b-container fluid class="m-0 p-0">
      <b-row class="m-0 align-items-center">
        <b-col class="my-1 text-right">
          <b-pagination
            v-model="currentPage"
            :total-rows="totalRows"
            :per-page="perPage"
            align="right"
            size="sm"
            class="my-0 float-right"
          ></b-pagination>
          <span class="label-current-page float-right py-2 mx-3"
            >{{ currentPage }} - {{ perPage }} of {{ perPage }}</span
          >
        </b-col>
      </b-row>
    </b-container>
    <b-navbar fixed="bottom" class="p-0 pl-3">
      <!-- <b-container fluid class="m-0 p-0">
        <b-row class="w-100 m-0">
          <b-col cols="1">
            <p class="m-0"></p>
          </b-col>
          <b-col cols="2">
            <p class="m-0">Total</p>
          </b-col>
          <b-col cols="1">
            <p class="m-0"></p>
          </b-col>
          <b-col cols="2">
            <p class="m-0 text-right">
              {{ $store.state.yearlyMember.summary.lifetimevalue }}
            </p>
          </b-col>
          <b-col cols="2">
            <p class="m-0 text-right">
              {{ $store.state.yearlyMember.summary.totaltransaction }}
            </p>
          </b-col>
          <b-col cols="2">
            <p class="m-0 text-right">
              {{ $store.state.yearlyMember.summary.totalpoint }}
            </p>
          </b-col>
          <b-col cols="2">
            <p class="m-0 text-right">
              {{ $store.state.yearlyMember.summary.remainingpoint }}
            </p>
          </b-col>
        </b-row>
      </b-container> -->
      <table class="w-100">
        <tbody>
          <tr>
            <th></th>
            <th class="text-center">Total</th>
            <th></th>
            <th class="text-right">
              {{ $store.state.yearlyMember.summary.lifetimevalue }}
            </th>
            <th class="text-right">
              {{ $store.state.yearlyMember.summary.totaltransaction }}
            </th>
            <th class="text-right">
              {{ $store.state.yearlyMember.summary.totalpoint }}
            </th>
            <th class="text-right">
              {{ $store.state.yearlyMember.summary.remainingpoint }}
            </th>
          </tr>
        </tbody>
      </table>
    </b-navbar>
  </div>
</template>

<script>
import { mapActions } from "vuex";
export default {
  name: "Home",
  components: {},
  data() {
    return {
      selectViewer: "year",
      year: new Date().toISOString().slice(0, 10),
      viewOptions: [
        { value: "year", text: "Year View" },
        { value: "month", text: "Month View" },
        { value: "week", text: "Week View" },
      ],
      fields: [
        {
          key: "customername",
          label: "Name",
          sortable: true,
          sortDirection: "desc",
          class: "text-left",
          thClass: "text-center",
        },
        {
          key: "customerphone",
          label: "ID",
          sortable: true,
          class: "text-center",
        },
        {
          key: "customertier",
          label: "Tier",
          sortable: true,
          class: "text-center",
        },
        {
          key: "totalamount",
          label: "LTV",
          sortable: true,
          class: "text-right",
          thClass: "text-center",
        },
        {
          key: "totaltransaction",
          label: "Total Trans.",
          sortable: true,
          class: "text-right",
          thClass: "text-center",
        },
        {
          key: "totalreward",
          label: "Total Point",
          sortable: true,
          class: "text-right",
          thClass: "text-center",
        },
        {
          key: "remainingpoint",
          label: "Remaining Point",
          sortable: true,
          class: "text-right",
          thClass: "text-center",
        },
      ],
      totalRows: 1,
      currentPage: 1,
      perPage: 5,
      pageOptions: [5, 10, 15, { value: 100, text: "Show a lot" }],
    };
  },
  methods: {
    ...mapActions(["getYearlyMember"]),
  },
  filters: {
    convertK(value) {
      if (value > 999 && value < 1000000) {
        return (value / 1000).toFixed(1) + "K";
      } else if (value > 1000000) {
        return (value / 1000000).toFixed(1) + "M";
      } else if (value < 900) {
        return value;
      }
    },
  },
  async mounted() {
    await this.$store.dispatch("getYearlyMember");
    this.totalRows = this.$store.state.yearlyMember.list.length;
  },
};
</script>

<style lang="scss">
#home {
  background-color: var(--base-bg);
  top: 100px;
  bottom: 30px;
  overflow-y: scroll;
  overflow-x: hidden;
  .title-header {
    .row-title {
      color: var(--master-color1);
      input {
        width: 160px;
      }
      .row-filter {
        max-width: 295px;
      }
    }
    .row-summary-tier .col-5 {
      background-color: var(--master-color1);
      color: var(--light-level4);
    }
    .row-summary-tier .col-7 {
      background-color: var(--base-table);
      color: var(--light-level4);
    }
  }
  .b-table {
    font-size: 0.8rem;
  }
  .b-table thead th {
    background-color: var(--base-table);
    color: var(--light-level4);
  }
  .label-current-page {
    font-size: 0.8rem;
  }
  .b-pagination {
    .page-link {
      color: var(--dark-level1) !important;
    }
    .page-item.active .page-link {
      background-color: var(--dark-level1) !important;
      border-color: var(--dark-level1) !important;
      color: var(--light-level4) !important;
    }
  }
  .navbar.fixed-bottom {
    background-color: var(--light-level4);
    color: var(--master-color1);
    font-size: 0.8rem;
    height: 30px;
    padding-right: 32px !important;
    table {
      table-layout: fixed;
      th {
        padding: 0.3rem;
      }
    }
  }
}
</style>
